=== debian/changelog ===
zydis (3.1.0-1) unstable; urgency=low

  * Initial release. Closes: #995921

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 08 Oct 2021 12:42:28 +0200
