=== debian/control ===
Source: zydis
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: debhelper-compat (= 13), cmake, libzycore-dev
Standards-Version: 4.6.0
Homepage: https://zydis.re
Rules-Requires-Root: no

Package: libzydis3.1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: fast and lightweight x86/x86-64 disassembler library
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and extensions, doesn't perform dynamic memory
 allocations, is thread safe by design and has no third party dependency -
 not even libc.
 .
 This package contains the shared library.

Package: libzydis-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libzydis3.1 (= ${binary:Version}),
Description: fast and lightweight x86/x86-64 disassembler library - development
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and extensions, doesn't perform dynamic memory
 allocations, is thread safe by design and has no third party dependency -
 not even libc.
 .
 This package contains the development files.
