=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_TARGET_MULTIARCH)" \
		-DZYDIS_BUILD_SHARED_LIB=ON \
		-DZYDIS_BUILD_EXAMPLES=OFF \
		-DZYDIS_BUILD_TOOLS=OFF \
		-DZYDIS_SYSTEM_ZYCORE=ON
