## zydis 3.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,10 @@
 cmake_minimum_required(VERSION 3.1 FATAL_ERROR)
+
+project(Zydis VERSION 3.2.1.0 LANGUAGES C CXX)
+
 include(GenerateExportHeader)
 include(GNUInstallDirs)
-
-project(Zydis VERSION 3.1.0.0 LANGUAGES C CXX)
+include(CMakePackageConfigHelpers)
 
 # =============================================================================================== #
 # Overridable options                                                                             #
@@ -50,6 +52,18 @@
 # =============================================================================================== #
 # Dependencies                                                                                    #
 # =============================================================================================== #
+
+# Try to initialize the Zycore submodule using Git
+if (NOT EXISTS "${ZYDIS_ZYCORE_PATH}/CMakeLists.txt" AND 
+    "${ZYDIS_ZYCORE_PATH}" STREQUAL "${CMAKE_CURRENT_LIST_DIR}/dependencies/zycore")
+    find_package(Git QUIET)
+    if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
+        execute_process(
+            COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive 
+            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} 
+        )
+    endif()
+endif ()
 
 if (NOT EXISTS "${ZYDIS_ZYCORE_PATH}/CMakeLists.txt")
     message(
@@ -77,9 +91,15 @@
 
 target_link_libraries("Zydis" PUBLIC "Zycore")
 target_include_directories("Zydis"
-    PUBLIC "include" ${PROJECT_BINARY_DIR}
+    PUBLIC
+        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
+        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
+        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
     PRIVATE "src")
 target_compile_definitions("Zydis" PRIVATE "_CRT_SECURE_NO_WARNINGS" "ZYDIS_EXPORTS")
+set_target_properties("Zydis" PROPERTIES
+    VERSION ${Zydis_VERSION}
+    SOVERSION ${Zydis_VERSION_MAJOR}.${Zydis_VERSION_MINOR})
 zyan_set_common_flags("Zydis")
 zyan_maybe_enable_wpo_for_lib("Zydis")
 generate_export_header("Zydis" BASE_NAME "ZYDIS" EXPORT_FILE_NAME "ZydisExportConfig.h")
@@ -157,11 +177,28 @@
 
 zyan_set_source_group("Zydis")
 
-# TODO: Install CMake config.
+configure_package_config_file(cmake/zydis-config.cmake.in
+    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config.cmake"
+    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zydis"
+)
+write_basic_package_version_file(
+    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config-version.cmake"
+    COMPATIBILITY SameMajorVersion
+)
+install(FILES
+    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config.cmake"
+    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config-version.cmake"
+    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zydis"
+)
+
 install(TARGETS "Zydis"
+    EXPORT "zydis-targets"
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+install(EXPORT "zydis-targets"
+    NAMESPACE "Zydis::"
+    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zydis")
 install(FILES
     "${PROJECT_BINARY_DIR}/ZydisExportConfig.h"
     DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
@@ -251,24 +288,3 @@
             target_compile_definitions("ZydisFuzzIn" PRIVATE "ZYDIS_FUZZ_AFL_FAST")
         endif ()
         if (ZYDIS_LIBFUZZER)
-            target_compile_definitions("ZydisFuzzIn" PRIVATE "ZYDIS_LIBFUZZER")
-        endif ()
-
-        add_executable("ZydisInfo" "tools/ZydisInfo.c")
-        target_link_libraries("ZydisInfo" "Zydis")
-        set_target_properties ("ZydisInfo" PROPERTIES FOLDER "Tools")
-        target_compile_definitions("ZydisInfo" PRIVATE "_CRT_SECURE_NO_WARNINGS")
-        zyan_set_common_flags("ZydisInfo")
-        zyan_maybe_enable_wpo("ZydisInfo")
-        _maybe_set_emscripten_cfg("ZydisInfo")
-        install(TARGETS "ZydisInfo" RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-
-        #add_executable("ZydisPE" "tools/ZydisPE.c")
-        #target_link_libraries("ZydisPE" "Zydis")
-        #set_target_properties ("ZydisPE" PROPERTIES FOLDER "Tools")
-        #target_compile_definitions("ZydisPE" PRIVATE "_CRT_SECURE_NO_WARNINGS")
-        #zyan_set_common_flags("ZydisPE")
-        #zyan_maybe_enable_wpo("ZydisPE")
-        #_maybe_set_emscripten_cfg("ZydisPE")
-    endif ()
-endif ()
