=== debian/control ===
Source: zydis
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libzycore-dev (>= 1.1.0-3),
               python3 <!nocheck>,
               ronn
Standards-Version: 4.6.0
Homepage: https://zydis.re
Vcs-Git: https://salsa.debian.org/debian/zydis.git
Vcs-Browser: https://salsa.debian.org/debian/zydis
Rules-Requires-Root: no

Package: libzydis3.2
Architecture: any-amd64 any-arm any-arm64 any-i386
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: fast and lightweight x86/x86-64 disassembler library
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and many vendor extensions, doesn't perform dynamic
 memory allocations, is thread safe by design and has no third party
 dependency - not even libc.
 .
 This package contains the shared library.

Package: libzydis-dev
Section: libdevel
Architecture: any-amd64 any-arm any-arm64 any-i386
Multi-Arch: same
Depends: libzycore-dev (>= 1.0.0-2),
         libzydis3.2 (= ${binary:Version}),
         ${misc:Depends}
Description: fast and lightweight x86/x86-64 disassembler library - development
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and many vendor extensions, doesn't perform dynamic
 memory allocations, is thread safe by design and has no third party
 dependency - not even libc.
 .
 This package contains the development files.

Package: zydis-tools
Section: devel
Architecture: any-amd64 any-arm any-arm64 any-i386
Multi-Arch: foreign
Depends: libzydis3.2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: fast and lightweight x86/x86-64 disassembler library - tools
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and many vendor extensions, doesn't perform dynamic
 memory allocations, is thread safe by design and has no third party
 dependency - not even libc.
 .
 This package contains the command line tools.
