=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=+all

%:
	dh $@ --builddir=build

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DZYDIS_BUILD_SHARED_LIB=ON \
		-DZYDIS_BUILD_EXAMPLES=OFF \
		-DZYDIS_BUILD_TOOLS=ON \
		-DZYDIS_SYSTEM_ZYCORE=ON \
		-DZYDIS_BUILD_MAN=ON \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON

override_dh_auto_test:
	cd tests && python3 regression.py test ../build/ZydisInfo
