=== debian/changelog ===
zydis (4.0.0-2.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:56:35 +1100

zydis (4.0.0-2.1build1) noble; urgency=medium

  * No-change rebuild against libzycore1.4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Mar 2024 05:58:01 +0000

zydis (4.0.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063315

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 08:51:11 +0000

zydis (4.0.0-2) unstable; urgency=medium

  * d/patches: add loong64 support.
    Thanks to wuruilong for the patch! (Closes: #1055146)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 12 Jan 2024 23:36:45 +0100

zydis (4.0.0-1) unstable; urgency=medium

  * New upstream version 4.0.0
  * Upload to unstable

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 24 Nov 2022 10:56:33 +0100

zydis (4.0.0~rc.1-1) experimental; urgency=medium

  * New upstream version 4.0.0~rc.1
  * d/control: libzydis3.2 -> libzydis4.0
  * d/control: add new libzydis-doc package
  * d/control: build on any architecture
  * d/patches: drop upstreamed patches

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 07 Nov 2022 01:39:25 +0100

zydis (3.2.1-6) unstable; urgency=medium

  * d/patches: build Doxygen documentation
  * d/rules: enable BUILD_RPATH_USE_ORIGIN
  * d/tests: add autopkgtests

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 02 Oct 2022 15:14:14 +0200
