=== debian/control ===
--- 
+++ 
@@ -1,20 +1,31 @@
 Source: zydis
 Section: libs
 Priority: optional
-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
-Build-Depends: cmake,
-               debhelper-compat (= 13),
-               libzycore-dev (>= 1.1.0-3),
-               python3 <!nocheck>,
-               ronn
-Standards-Version: 4.6.0
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
+Build-Depends-Arch: dpkg-dev (>= 1.22.5), cmake,
+                    libzycore-dev (>= 1.1.0-3),
+                    python3 <!nocheck>,
+                    ronn
+Build-Depends-Indep: cmake,
+                     doxygen <!nodoc>,
+                     doxygen-awesome-css <!nodoc>,
+                     graphviz <!nodoc>,
+                     libzycore-dev (>= 1.1.0-3),
+                     python3 <!nocheck>,
+                     ronn
+Standards-Version: 4.6.2
 Homepage: https://zydis.re
 Vcs-Git: https://salsa.debian.org/debian/zydis.git
 Vcs-Browser: https://salsa.debian.org/debian/zydis
 Rules-Requires-Root: no
 
-Package: libzydis3.2
-Architecture: any-amd64 any-arm any-arm64 any-i386
+Package: libzydis4.0t64
+Provides: ${t64:Provides}
+Replaces: libzydis4.0
+Breaks: libzydis4.0 (<< ${source:Version})
+Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends},
          ${shlibs:Depends}
@@ -28,10 +39,10 @@
 
 Package: libzydis-dev
 Section: libdevel
-Architecture: any-amd64 any-arm any-arm64 any-i386
+Architecture: any
 Multi-Arch: same
 Depends: libzycore-dev (>= 1.0.0-2),
-         libzydis3.2 (= ${binary:Version}),
+         libzydis4.0t64 (= ${binary:Version}),
          ${misc:Depends}
 Description: fast and lightweight x86/x86-64 disassembler library - development
  Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
@@ -41,11 +52,24 @@
  .
  This package contains the development files.
 
+Package: libzydis-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Description: fast and lightweight x86/x86-64 disassembler library - documentation
+ Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
+ AMD64 instructions and many vendor extensions, doesn't perform dynamic
+ memory allocations, is thread safe by design and has no third party
+ dependency - not even libc.
+ .
+ This package contains the generated Doxygen documentation.
+
 Package: zydis-tools
 Section: devel
-Architecture: any-amd64 any-arm any-arm64 any-i386
+Architecture: any
 Multi-Arch: foreign
-Depends: libzydis3.2 (= ${binary:Version}),
+Depends: libzydis4.0t64 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: fast and lightweight x86/x86-64 disassembler library - tools
