=== debian/rules ===
#!/usr/bin/make -f

# optimize=-lto because I use CMake's LTO
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto qa=+all

%:
	dh $@ --builddir=build

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=ON \
		-DCMAKE_POLICY_DEFAULT_CMP0069=NEW \
		-DBUILD_SHARED_LIBS=ON \
		-DZYDIS_BUILD_SHARED_LIB=ON \
		-DZYDIS_BUILD_EXAMPLES=OFF \
		-DZYDIS_BUILD_TOOLS=ON \
		-DZYAN_SYSTEM_ZYCORE=ON \
		-DZYDIS_BUILD_MAN=ON \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON

override_dh_auto_test:
	cd tests && python3 regression.py test ../build/ZydisInfo

override_dh_installdocs-indep:
	dh_installdocs --indep --doc-main-package=libzydis-doc

override_dh_installexamples-indep:
	dh_installexamples --indep --doc-main-package=libzydis-doc

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
execute_after_dh_installdocs-indep:
	dh_doxygen --indep
endif
