=== debian/tests/control ===
Tests: cmake
Depends: @, cmake, gcc | c-compiler, libc-dev
