## zydis 4.1.0

=== Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 	@if ! command -v cmake > /dev/null; then \
 		echo >&2 "ERROR: cmake is not installed. Please install it first."; \
 	fi
-	cmake -B $(BUILD_DIR)
+	cmake -B $(BUILD_DIR) -DZYDIS_BUILD_TESTS=ON
 
 install: build
 	cmake --install $(BUILD_DIR)
@@ -24,8 +24,7 @@
 	rm -rf amalgamated-dist
 
 test: build
-	cd tests && ./regression.py test ../build/ZydisInfo
-	cd tests && ./regression_encoder.py ../build/Zydis{Fuzz{ReEncoding,Encoder},TestEncoderAbsolute}
+	cd $(BUILD_DIR) && ctest
 
 doc: configure
 	cmake --build $(BUILD_DIR) --target ZydisDoc
