=== debian/changelog ===
zydis (4.1.0-3) unstable; urgency=low

  * Upload to unstable
  * First dgit upload

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 14 Jan 2025 22:24:32 +0100

zydis (4.1.0-2) experimental; urgency=medium

  * d/.symbols: drop ZydisStringAppend*U32 symbols

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 10 Apr 2024 07:36:44 +0200

zydis (4.1.0-1) experimental; urgency=medium

  * New upstream version 4.1.0
  * d/control: libzydis4.0 -> libzydis4.1
  * d/control: build-depend on libzycore-dev >= 1.5.0
  * d/.manpages: list files instead of directories
  * d/patches: refresh patches and drop upstreamed ones
  * d/rules: run tests with CMake

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 10 Mar 2024 14:00:34 +0100
