=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: zydis
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
+Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
-Build-Depends-Arch: dpkg-dev (>= 1.22.5), cmake,
-                    libzycore-dev (>= 1.1.0-3),
+Build-Depends-Arch: cmake,
+                    libzycore-dev (>= 1.5.0),
                     python3 <!nocheck>,
                     ronn
 Build-Depends-Indep: cmake,
                      doxygen <!nodoc>,
                      doxygen-awesome-css <!nodoc>,
                      graphviz <!nodoc>,
-                     libzycore-dev (>= 1.1.0-3),
+                     libzycore-dev (>= 1.5.0),
                      python3 <!nocheck>,
                      ronn
 Standards-Version: 4.6.2
@@ -21,10 +20,7 @@
 Vcs-Browser: https://salsa.debian.org/debian/zydis
 Rules-Requires-Root: no
 
-Package: libzydis4.0t64
-Provides: ${t64:Provides}
-Replaces: libzydis4.0
-Breaks: libzydis4.0 (<< ${source:Version})
+Package: libzydis4.1
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends},
@@ -42,7 +38,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: libzycore-dev (>= 1.0.0-2),
-         libzydis4.0t64 (= ${binary:Version}),
+         libzydis4.1 (= ${binary:Version}),
          ${misc:Depends}
 Description: fast and lightweight x86/x86-64 disassembler library - development
  Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
@@ -69,7 +65,7 @@
 Section: devel
 Architecture: any
 Multi-Arch: foreign
-Depends: libzydis4.0t64 (= ${binary:Version}),
+Depends: libzydis4.1 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: fast and lightweight x86/x86-64 disassembler library - tools
