=== debian/rules ===
--- 
+++ 
@@ -16,10 +16,8 @@
 		-DZYDIS_BUILD_TOOLS=ON \
 		-DZYAN_SYSTEM_ZYCORE=ON \
 		-DZYDIS_BUILD_MAN=ON \
+		-DZYDIS_BUILD_TESTS=ON \
 		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON
-
-override_dh_auto_test:
-	cd tests && python3 regression.py test ../build/ZydisInfo
 
 override_dh_installdocs-indep:
 	dh_installdocs --indep --doc-main-package=libzydis-doc
